﻿using System.Collections.Generic;
using DoxygenTest.CollectionPopulation;

/// \package DoxygenTest
/// <summary> This namespace (package) encapsulates the entire application.</summary>
// <remarks> The <see cref="Program.Main">Main</see> method can be found here in the Program class.
// </remarks>
namespace DoxygenTest
{

  /// <summary>
  /// Collection class holding instances of CollectionPopulation.Member.
  /// </summary>
  /// <remarks>This one is shown correct in the documentation.</remarks>
  class WorkingReference : List<Member>
  {
    /// <summary>
    /// Does the stuff.
    /// </summary>
    /// <returns></returns>
    public int DoStuff()
    {
      return Count;
    }
  }

  /// <summary>
  /// Collection class holding instances of Member.
  /// </summary>
  /// <remarks>This one is shown incorrect in the documentation.</remarks>
  class NotWorkingReference : List<Member>
  {
    /// <summary>
    /// Does the other stuff.
    /// </summary>
    /// <returns></returns>
    public int DoOtherStuff()
    {
      return Count;
    }
  }

  /// <summary>
  /// Namespace documentation.
  /// </summary>
  namespace CollectionPopulation
  {
    /// <summary>
    /// Object to populate a collection with.
    /// </summary>
    class Member
    {
      /// <summary>
      /// Initializes a new instance of the <see cref="Member"/> class.
      /// </summary>
      public Member()
      {
      }
    }
  }
}
